Index: anuga_work/development/boxingday08/boxingday_boundary_order.txt
===================================================================
--- anuga_work/development/boxingday08/boxingday_boundary_order.txt	(revision 5464)
+++ anuga_work/development/boxingday08/boxingday_boundary_order.txt	(revision 5465)
@@ -1,95 +1,95 @@
-index,longitude,latitude
-90,472194.058708,193430.03714
-91,468910.350862,417814.660921
-0,336294.174659,659735.865848
-1,335940.023759,664344.009834
-2,335585.169534,668952.072994
-3,333458.007771,671787.84005
-4,333103.527881,676395.93421
-5,335584.913055,679586.176909
-6,338066.17797,683130.901664
-7,337712.337412,687384.526034
-8,340193.365548,691283.679243
-9,342674.942465,695182.864565
-10,343028.996544,698727.563095
-11,343383.181996,702626.692455
-12,345510.456522,706171.398037
-13,347636.763496,710070.561254
-14,348345.993026,713969.747598
-15,347991.999887,717868.90241
-16,348700.260229,721413.598337
-17,348700.74816,725312.746857
-18,348346.261066,729566.410886
-19,347637.463051,733465.539648
-20,346219.280415,737010.261839
-21,345864.407267,741263.85975
-22,345510.331768,745163.03914
-23,342674.316521,747289.866983
-24,340547.547708,750480.065429
-25,339484.479114,755088.19808
-26,341965.31107,757923.969427
-27,343028.978631,761468.662515
-28,338420.592193,761823.097012
-29,335585.22943,764304.383975
-30,334167.626591,768203.581251
-31,335584.735827,771393.786837
-32,337003.09138,775292.952764
-33,335939.319181,779546.605803
-34,333103.507345,782027.857453
-35,329204.500134,783800.237744
-36,327432.550064,787699.371861
-37,328141.129947,790889.621245
-38,329204.642377,795143.228566
-39,330268.050113,799396.879865
-40,331331.840794,803296.055516
-41,332394.68402,807195.228032
-42,332749.712168,811803.336354
-43,332749.085392,815347.988474
-44,331686.000498,819247.16197
-45,330977.236649,823500.800482
-46,330622.34502,827754.458718
-47,330268.46938,831299.140929
-48,329913.427618,835198.318404
-49,328141.18488,838742.994622
-50,325305.544465,841933.245518
-51,323533.487091,845123.425076
-52,321051.760662,848668.14935
-53,321051.898764,852921.802336
-54,320343.173374,857529.873001
-55,316443.694676,860011.188558
-56,312898.80714,861429.03829
-57,310772.31805,864973.73467
-58,309354.462261,868872.930518
-59,305454.953286,870999.733764
-60,301555.903121,872772.053637
-61,299429.071562,876671.238128
-62,299075.077259,880924.887741
-63,298365.530409,884824.028562
-64,297302.823004,889077.699828
-65,294820.924212,892267.85487
-66,290922.375994,894394.741886
-67,287377.363778,896167.086731
-68,284895.736516,899711.774988
-69,283123.376077,902901.93998
-70,280997.234969,905737.733813
-71,278515.811642,908927.944896
-72,277097.388615,911763.685916
-73,276389.008202,915308.431193
-74,277452.296071,919562.067608
-75,277097.344968,923461.192048
-76,274616.125999,927360.398292
-77,272489.492172,930196.118259
-78,270008.294828,932677.417175
-79,266817.763524,935867.66411
-80,262919.01753,937639.955008
-81,258665.020804,936576.567479
-82,254411.760125,936576.586726
-83,257956.617175,988187.298388
-85,431895.346948,1020339.55099
-84,456154.607059,1099910.74796
-87,485676.850637,892038.719914
-86,436057.013086,865548.249097
-93,422179.921754,873660.847571
-92,417478.780955,873745.865662
-88,533099.268408,829034.042352
-89,571839.718716,740632.637627
+index, longitude, latitude
+90,98.75,1.75
+91,98.7200012207,3.77999997139
+0,97.5210189819,5.96663379669
+1,97.5177078247,6.00829792023
+2,97.5143890381,6.04996109009
+3,97.4951019287,6.07555246353
+4,97.4917831421,6.11721515656
+5,97.5141220093,6.14612770081
+6,97.5364532471,6.17824554443
+7,97.5331497192,6.21670341492
+8,97.5554733276,6.25202655792
+9,97.5778045654,6.28734970093
+10,97.5809173584,6.31941461563
+11,97.584022522,6.35468482971
+12,97.6031646729,6.38679361343
+13,97.6222915649,6.42210769653
+14,97.6286087036,6.45738744736
+15,97.6253128052,6.49264097214
+16,97.6316299438,6.52471494675
+17,97.6315383911,6.5599770546
+18,97.6282272339,6.59843635559
+19,97.6217193604,6.63368034363
+20,97.6088027954,6.66570091248
+21,97.6054840088,6.70415878296
+22,97.602180481,6.73941135406
+23,97.5764694214,6.75857067108
+24,97.557144165,6.78736352921
+25,97.5474014282,6.82900667191
+26,97.569770813,6.85471820831
+27,97.5792999268,6.8868021965
+28,97.5375900269,6.88988161087
+29,97.5118637085,6.91224050522
+30,97.4989242554,6.94746017456
+31,97.5116577148,6.97634935379
+32,97.5243835449,7.01164960861
+33,97.5146331787,7.05008459091
+34,97.4888916016,7.07243967056
+35,97.4535446167,7.08835077286
+36,97.4373855591,7.12355518341
+37,97.4437026978,7.15242481232
+38,97.4532012939,7.19092082977
+39,97.4626998901,7.22941732407
+40,97.4722137451,7.26470851898
+41,97.4817199707,7.2999997139
+42,97.4847946167,7.3416800499
+43,97.4846801758,7.37373304367
+44,97.4749298096,7.4089589119
+45,97.4683761597,7.44740056992
+46,97.4650268555,7.48585319519
+47,97.4617080688,7.51789474487
+48,97.458366394,7.55314159393
+49,97.4421920776,7.58513689041
+50,97.4163894653,7.61389112473
+51,97.4002227783,7.6426782608
+52,97.3776092529,7.67464590073
+53,97.3774642944,7.71310758591
+54,97.370880127,7.7547492981
+55,97.3354415894,7.77704811096
+56,97.3032531738,7.78974056244
+57,97.2838439941,7.8217124939
+58,97.2708435059,7.85691452026
+59,97.2354049683,7.87599658966
+60,97.1999816895,7.89187002182
+61,97.1805419922,7.92703914642
+62,97.1771621704,7.96548223495
+63,97.1705703735,8.00070571899
+64,97.1607589722,8.03911972046
+65,97.1381149292,8.06785964966
+66,97.1026611328,8.08692550659
+67,97.0704269409,8.10279750824
+68,97.0477600098,8.13473510742
+69,97.031539917,8.16349697113
+70,97.0121231079,8.18903827667
+71,96.9894638062,8.21776580811
+72,96.9764633179,8.24333572388
+73,96.969871521,8.27534675598
+74,96.9793243408,8.31384754181
+75,96.9759216309,8.34907817841
+76,96.9532165527,8.38420963287
+77,96.9337768555,8.40974235535
+78,96.9111328125,8.4320526123
+79,96.8820114136,8.46073436737
+80,96.8465270996,8.47656059265
+81,96.8079605103,8.4667339325
+82,96.7693481445,8.46651554108
+83,96.7988052368,8.93318271637
+85,98.3799972534,9.22999954224
+84,98.5999984741,9.94999980927
+87,98.8700027466,8.06999969482
+86,98.4199981689,7.82999992371
+93,98.2940063477,7.90318584442
+92,98.2513580322,7.90388059616
+88,99.3000030518,7.5
+89,99.6500015259,6.69999980927