Index: /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-e-mux.lic
===================================================================
--- /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-e-mux.lic	(revision 5504)
+++ /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-e-mux.lic	(revision 5504)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="iso-8859-1"?>
+
+  <ga_license_file>
+    <metadata>
+      <author>Duncan Gray</author>
+    </metadata>
+    <datafile>
+      <filename>o_test_velocity-e-mux.mux</filename>
+      <checksum>-1664514244</checksum>
+      <publishable>Yes</publishable>
+      <accountable>Duncan Gray</accountable>
+      <source>Generated by David Burbidge</source>
+      <IP_owner>Geoscience Australia.  See Geoscience Australia TRIM D2008-32621</IP_owner>
+      <IP_info>For use with URS mux files validation</IP_info>
+    </datafile>
+
+  </ga_license_file>
Index: /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-n-mux.lic
===================================================================
--- /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-n-mux.lic	(revision 5504)
+++ /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-n-mux.lic	(revision 5504)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="iso-8859-1"?>
+
+  <ga_license_file>
+    <metadata>
+      <author>Duncan Gray</author>
+    </metadata>
+    <datafile>
+      <filename>o_test_velocity-n-mux.mux</filename>
+      <checksum>364865864</checksum>
+      <publishable>Yes</publishable>
+      <accountable>Duncan Gray</accountable>
+      <source>Generated by David Burbidge</source>
+      <IP_owner>Geoscience Australia. See Geoscience Australia TRIM D2008-32621</IP_owner>
+      <IP_info>For use with URS mux files validation</IP_info>
+    </datafile>
+
+  </ga_license_file>
Index: /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-z.lic
===================================================================
--- /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-z.lic	(revision 5504)
+++ /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test-z.lic	(revision 5504)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="iso-8859-1"?>
+
+  <ga_license_file>
+    <metadata>
+      <author>Duncan Gray</author>
+    </metadata>
+    <datafile>
+      <filename>o_test_waveheight-z-mux.mux</filename>
+      <checksum>-1449856062</checksum>
+      <publishable>Yes</publishable>
+      <accountable>Duncan Gray</accountable>
+      <source>Generated by David Burbidge</source>
+      <IP_owner>Geoscience Australia. See Geoscience Australia TRIM D2008-32621</IP_owner>
+      <IP_info>For use with URS mux files validation</IP_info>
+    </datafile>
+
+  </ga_license_file>
Index: uga_validation/automated_validation_tests/urs_mux_files_validation/o_test_velocity-e-mux.lic
===================================================================
--- /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test_velocity-e-mux.lic	(revision 5503)
+++ 	(revision )
@@ -1,17 +1,0 @@
-<?xml version="1.0" encoding="iso-8859-1"?>
-
-  <ga_license_file>
-    <metadata>
-      <author>Duncan Gray</author>
-    </metadata>
-    <datafile>
-      <filename>o_test_velocity-e-mux.mux</filename>
-      <checksum>-1664514244</checksum>
-      <publishable>Yes</publishable>
-      <accountable>Duncan Gray</accountable>
-      <source>Generated by David Burbidge</source>
-      <IP_owner>Geoscience Australia.  See Geoscience Australia TRIM D2008-32621</IP_owner>
-      <IP_info>For use with URS mux files validation</IP_info>
-    </datafile>
-
-  </ga_license_file>
Index: uga_validation/automated_validation_tests/urs_mux_files_validation/o_test_velocity-n-mux.lic
===================================================================
--- /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test_velocity-n-mux.lic	(revision 5503)
+++ 	(revision )
@@ -1,17 +1,0 @@
-<?xml version="1.0" encoding="iso-8859-1"?>
-
-  <ga_license_file>
-    <metadata>
-      <author>Duncan Gray</author>
-    </metadata>
-    <datafile>
-      <filename>o_test_velocity-n-mux.mux</filename>
-      <checksum>364865864</checksum>
-      <publishable>Yes</publishable>
-      <accountable>Duncan Gray</accountable>
-      <source>Generated by David Burbidge</source>
-      <IP_owner>Geoscience Australia. See Geoscience Australia TRIM D2008-32621</IP_owner>
-      <IP_info>For use with URS mux files validation</IP_info>
-    </datafile>
-
-  </ga_license_file>
Index: uga_validation/automated_validation_tests/urs_mux_files_validation/o_test_waveheight-z-mux.lic
===================================================================
--- /anuga_validation/automated_validation_tests/urs_mux_files_validation/o_test_waveheight-z-mux.lic	(revision 5503)
+++ 	(revision )
@@ -1,17 +1,0 @@
-<?xml version="1.0" encoding="iso-8859-1"?>
-
-  <ga_license_file>
-    <metadata>
-      <author>Duncan Gray</author>
-    </metadata>
-    <datafile>
-      <filename>o_test_waveheight-z-mux.mux</filename>
-      <checksum>-1449856062</checksum>
-      <publishable>Yes</publishable>
-      <accountable>Duncan Gray</accountable>
-      <source>Generated by David Burbidge</source>
-      <IP_owner>Geoscience Australia. See Geoscience Australia TRIM D2008-32621</IP_owner>
-      <IP_info>For use with URS mux files validation</IP_info>
-    </datafile>
-
-  </ga_license_file>